<template>
  <div>
    <div id="chart-modules" style="height: 580px"></div>
  </div>
</template>

<script>
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
am4core.useTheme(am4themes_animated);
export default {
  mounted() {
    this.createChart();
  },
  beforeDestroy() {
    if (this.chartModules) {
      this.chartModules.dispose();
    }
  },
  methods: {
    createChart() {
      let chartModules = am4core.create(
        "chart-modules",
        am4charts.ChordDiagram
      );
      chartModules.hiddenState.properties.opacity = 0;

      let data = [];
      let letters = [
        "Avaliação de Maturidade",
        "Planejamento Estratégico",
        "Gestão de Riscos",
        "Gestão de Processos",
        "Gestão de Planos",
      ];

      function randomLetter(except) {
        let letter = letters[Math.floor(Math.random() * (letters.length - 1))];
        if (letter == except) {
          return randomLetter(except);
        } else {
          return letter;
        }
      }

      for (var i = 0; i < letters.length; i++) {
        let fromLetter = letters[i];
        for (var o = 0; o < 3; o++) {
          data.push({
            from: fromLetter,
            to: randomLetter(fromLetter),
            value: Math.round(Math.random() * 100),
          });
        }
      }

      chartModules.data = data;

      chartModules.dataFields.fromName = "from";
      chartModules.dataFields.toName = "to";
      chartModules.dataFields.value = "value";
      chartModules.nonRibbon = true;
      chartModules.sortBy = "name";
      chartModules.startAngle = 90;
      chartModules.endAngle = 450;

      let nodeTemplate = chartModules.nodes.template;
      nodeTemplate.fill = chartModules.colors.getIndex(0);
      nodeTemplate.fillOpacity = 0.4;
      nodeTemplate.slice.disabled = true;
      nodeTemplate.setStateOnChildren = true;
      nodeTemplate.label.disabled = true;
      nodeTemplate.togglable = false;

      nodeTemplate.readerTitle = "Drag to rearrange";
      nodeTemplate.showSystemTooltip = true;

      let hoverState = nodeTemplate.states.create("hover");
      hoverState.properties.fillOpacity = 1;

      let linkTemplate = chartModules.links.template;
      linkTemplate.opacity = 0.1;
      linkTemplate.stroke = chartModules.colors.getIndex(0);
      linkTemplate.defaultState.properties.opacity = 0.1;
      linkTemplate.tooltipText = "";

      let linkHoverState = linkTemplate.states.create("hover");
      linkHoverState.properties.opacity = 1;

      nodeTemplate.events.on("over", function (event) {
        let node = event.target;
        node.outgoingDataItems.each(function (dataItem) {
          dataItem.link.isHover = true;
        });
      });

      nodeTemplate.events.on("out", function (event) {
        let node = event.target;
        node.outgoingDataItems.each(function (dataItem) {
          dataItem.link.isHover = false;
        });
      });

      nodeTemplate.cursorOverStyle = am4core.MouseCursorStyle.grab;

      nodeTemplate.cursorDownStyle = am4core.MouseCursorStyle.grabbing;

      let circleBullet = nodeTemplate.createChild(am4charts.CircleBullet);
      circleBullet.setStateOnChildren = true;
      circleBullet.circle.radius = 75;

      let circleHoverState = circleBullet.states.create("hover");
      circleHoverState.properties.scale = 1.5;

      // we create a separate label as node.label ispositioned differently and doesn't fit perfectly for one-letter labels
      let label = circleBullet.createChild(am4core.Label);
      label.text = "{name}";
      label.horizontalCenter = "middle";
      label.verticalCenter = "middle";

      let labelHoverState = label.states.create("hover");
      labelHoverState.properties.fill = am4core.color("#ffffff");
    },
  },
};
</script>
